package com.akamai.osmf.samples.presenter
{
	import com.akamai.osmf.samples.view.BaseVideoView;
	import com.akamai.osmf.utils.AkamaiStrings;
	
	import org.osmf.media.MediaFactory;
	import org.osmf.media.MediaPlayer;
	import org.osmf.media.URLResource;
	import org.osmf.metadata.Metadata;
	import org.osmf.net.StreamType;
	import org.osmf.net.StreamingURLResource;
	
	public class MetadataControlBarPresenter extends BaseControlBarPresenter
	{
		private var resource:StreamingURLResource;
		
		public function MetadataControlBarPresenter(view:BaseVideoView, mediaPlayer:MediaPlayer, mediaFactory:MediaFactory, mediaResource:String)
		{				
			resource = new StreamingURLResource(mediaResource, StreamType.LIVE_OR_RECORDED);
						
			addMetadata(resource);
			
			super(view, mediaPlayer, mediaFactory, mediaResource);
		}
		
		override protected function setupMediaPlayer():void
		{
			mediaPlayer.autoPlay = false;
			setupMediaPlayerListeners();
			mediaPlayer.media = mediaFactory.createMediaElement(resource);
		}
		
		private function addMetadata(resource:URLResource):void
		{
			var metadata:Metadata = resource.getMetadataValue(AkamaiStrings.AKAMAI_ADVANCED_STREAMING_PLUGIN_METADATA_NAMESPACE)
				as Metadata;
			if (metadata == null)
			{
				metadata = new Metadata();		
			}
			
			// See the AkamaiStrings class for an explaination of the available metadata keys and formats for their values

			metadata.addValue(AkamaiStrings.AKAMAI_METADATA_KEY_MBR_STARTING_INDEX, 2);
			
			resource.addMetadataValue(AkamaiStrings.AKAMAI_ADVANCED_STREAMING_PLUGIN_METADATA_NAMESPACE, metadata);			
		}
		
	}
}
